#!/bin/bash

set -e

SSH_DIR="/opt/botguard/var/lib/botguard/ssh"
SSH_KEY="$SSH_DIR/id_ed25519"
BOTGUARD_SSH_DIR="/home/botguard/.ssh"
AUTHORIZED_KEYS="$BOTGUARD_SSH_DIR/authorized_keys"

if [ -f "$SSH_KEY" ]; then
    exit 0
fi

mkdir -p "$SSH_DIR"
chmod 0700 "$SSH_DIR"
ls "$SSH_KEY" 2>/dev/null || /usr/bin/ssh-keygen -N '' -t ed25519 -q -f "$SSH_KEY"
chown www-data:www-data -R "$SSH_DIR"

mkdir -p "$BOTGUARD_SSH_DIR"
chmod 0700 "$BOTGUARD_SSH_DIR"
cat "${SSH_KEY}.pub" >> "$AUTHORIZED_KEYS"
/usr/bin/chown botguard:botguard -R "$BOTGUARD_SSH_DIR"

echo "BotGuard SSH key has been generated and added to authorized_keys:"
ls -la "$SSH_KEY"

exit 0